/*
 * Copyright (c) 2011, 2012, Endea.org
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package endea

import endea.secure._
import endea.html._
import endea.http._
import endea.io.io._
import scala.collection.mutable.HashMap

object User {

  val user_key = "me"
  val user_uri = Controller.encodeSession(User.user_key, EntityAction)

  // TODO tmp !!!
  val users = new HashMap[String, User]
  val url = classOf[User].getResource("/users.txt")
  if (url != null) {
    for (line <- url.openStream.getLines()) {
      val tokens = line.trim.split("\\s+")
      if (tokens.length > 1)
        users += tokens(0) -> new User(tokens(1))
    }
  }

  def logIn(event: Event[_], name: String, password: String): Option[User] = {

    val optUser = users.get(name)
    if (optUser.isDefined)
      event.session.put(user_key, optUser.get)
    optUser
  }

  def logOut(event: Event[_]) {
    event.session.remove(user_key)
  }
}

class User(

  var name: String) extends Entity {

  override def toString = name
}

