/*
 * Copyright (c) 2012, Endea.org
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package endea.html

import endea.http.Event
import endea._

object IndexAdapter {

  def write(event: Event[_], index: Index[_, _], name: String, value: String) {

    event.write("""<form action="""")
    event.write("/item")
    event.write(""""><label>""")
    event.write(name)
    event.write("""</label><input type="text" name="""")
    event.write(name)
    if (value != null) {
      event.write("""" value="""")
      event.write(value)
    }
    event.write(""""/>
</form>""")

    if (value != null) {

      var rows = 10

      event.write("<hr/>")

      event.write("<ul>")
      index.asInstanceOf[Index[String, Entity]].get(value, _.take(rows).foreach(
        entity => {
          event.write("<li>")
          Link.write(event, entity)
          event.write("</li>")
        }))
      event.write("</ul>")
    }
  }
}