/*
 * Copyright (c) 2012, Endea.org
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package endea.http

import endea.Entity
import endea.html.EntityAction
import endea.html.EntityTypeAction
import endea.internal.html.DocumentAction
import endea.internal.secure.LoginAction
import endea.internal.secure.LogoutAction
import endea.internal.secure.UserAction

object HttpConfig {

  private var _actions: Seq[HttpAction[_ <: Entity]] = Seq(
    EntityAction,
    EntityTypeAction,
    DocumentAction,
    LogoutAction,
    LoginAction,
    UserAction)

  def actions = _actions

  def ++(actions: Seq[HttpAction[_ <: Entity]]) = _actions ++= actions

}