/*
 * Copyright (c) 2012, Endea.org
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package endea.internal.io

import endea.io._
import endea.io.io._
import java.net.URL
import java.io.{ File => JFile }

class URLEnhancer(self: URL) {

  def crc(): Long = self.openStream().crc

  def file(): Option[File] = {
    if (self.getProtocol != "file")
      None
    else
      Some(File(self.getFile))
  }
}